/*->c.err */


#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"

#include "trans.h"
#include "etc.h"

#include "err.h"


static os_error   errblock;
static errlink  * firstlink;

#define LOCALERROR 0x0       // used to prevent error numbers going back to OS
                             // don't use here will upset things


os_error * adderrortable(errtag * tags,errlink * link)
{
 link->tags=tags;
 link->next=firstlink;
 firstlink=link;

 return(NULL);
}


static char * errmsg(int errno)
{
 errlink  * link;
 errtag   * tag;

 link=firstlink;

 while(link)
 {
  tag=link->tags;
  while(tag->xerrno!=ELAST)
  {
   if(tag->xerrno==errno)
   {
    return(tag->errmsg);
   }
   tag++;
  }
  link=link->next;
 }

 return("{ENOE}");
}


os_error * geterror(int errno)
{
 os_error * err;

 if(!errno) return(NULL);

 errblock.errnum=errno;
 strcpy(errblock.errmess,errmsg(errno));
 err=trans(errblock.errmess,sizeof(errblock.errmess));
 if(!err) err=&errblock;
 return(err);
}


os_error * geterrorf(int errno,...)
{
 va_list    args;
 char       format[256];
 os_error * err;

 errblock.errnum=errno;
 strcpy(format,errmsg(errno));
 trans(format,sizeof(format));

 va_start(args,errno);
 vsprintf(errblock.errmess,format,args);
 va_end(args);

 err=trans(errblock.errmess,sizeof(errblock.errmess));
 if(!err) err=&errblock;
 return(err);
}


os_error * generror(int errno,char * format, ...)
{
 va_list    args;
 os_error * err;

 errblock.errnum=errno;

 va_start(args,format);
 vsprintf(errblock.errmess,format,args);
 va_end(args);

 err=trans(errblock.errmess,sizeof(errblock.errmess));
 if(!err) err=&errblock;

 return(err);
 USE(errno);
}


os_error * erroradd(os_error * err1,os_error * err2)
{
 if(err1) return(err1);
 else     return(err2);
}


os_error * initerror(void)
{
 firstlink=NULL;
 return(NULL);
}


