/*->c.im */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"


#include "err.h"
#include "alloc.h"
#include "fsx.h"
#include "etc.h"



#include "str.h"

#include "main.h"



#include "im.h"



/*****************************************************************************/
/* return pointers to row data */




os_error * imfind1r(imagestr * ip,int y,int ** data)
{
 *data=ip->data+y*ip->wwidth;
 return(NULL);
}




os_error * imfind1w(imagestr * ip,int y,int ** data)
{
 *data=ip->data+y*ip->wwidth;
 return(NULL);
}



os_error * imfind2rr(imagestr * ip1,int y1,int ** data1,
                     imagestr * ip2,int y2,int ** data2)
{
 *data1=ip1->data+y1*ip1->wwidth;
 *data2=ip2->data+y2*ip2->wwidth;
 return(NULL);
}


os_error * imfind2ww(imagestr * ip1,int y1,int ** data1,
                     imagestr * ip2,int y2,int ** data2)
{
 *data1=ip1->data+y1*ip1->wwidth;
 *data2=ip2->data+y2*ip2->wwidth;
 return(NULL);
}


/* throw away image */

os_error * imtrash(imagestr ** imp)
{
 os_error * err;
 imagestr * ip;

 err=NULL;

 ip=*imp;
 if(ip)
 {

  err=sfree((flex_ptr)imp);
 }

 return(err);
}





os_error * ximtrash(ximagestr ** ximp)
{
 os_error * err;

          err=imtrash(&((*ximp)->sim[IM]));
 if(!err) err=imtrash(&((*ximp)->sim[AL]));
 if(!err) err=sfree((flex_ptr)ximp);

 return(err);
}






/* create a new image */

/* bpp supports 1,2,4,8,24,32 */

os_error * imnew(int xpix,int ypix,int bpp,imagestr ** imp)
{
 os_error   * err;
 int          bitwidth;
 int          size;
 imagestr   * ip;



 bitwidth=(xpix*bpp+31)&(~31);
 bitwidth/=8;
 size=bitwidth*ypix; /* bytes */


 err=salloc((flex_ptr)imp,sizeof(imagestr)+size);

 if(!err)
 {
  ip=*imp;
  ip->wwidth=bitwidth/4; /* words */
  ip->xpix=xpix;
  ip->ypix=ypix;
  ip->bpp=bpp;
 }

 return(err);
}





os_error * ximnew(int xpix,int ypix,int bpp,ximagestr ** imp)
{
 os_error   * err;

 err=salloc((flex_ptr)imp,sizeof(ximagestr));
 if(!err)
 {
  err=imnew(xpix,ypix,bpp,&((*imp)->sim[IM]));
 }

 return(err);
}






void  shiftline(int * wdata,int xpix,int bpp,int rshift)
{
 unsigned int w;
 unsigned int r;
 int          x;
 int        * rdata;
 int          wshift;

 rdata=wdata;
 r=*rdata++;
 w=0;
 wshift=0;

 for(x=0;x<xpix;x++)
 {
  w|=(r>>rshift)<<wshift;
  rshift+=bpp;
  if(rshift>=32)
  {
   rshift=0;
   r=*rdata++;
  }
  wshift+=bpp;
  if(wshift>=32)
  {
   *wdata++=w;
   wshift=0;
   w=0;
  }
 }
 if(wshift) *wdata=w;
}






os_error * ximnew2(int xpix,int ypix,int bpp,int mpp,ximagestr ** imp)
{
 os_error * err;

 err=salloc((flex_ptr)imp,sizeof(ximagestr));
 if(!err)
 {
                    err=imnew(xpix,ypix,bpp,&((*imp)->sim[IM]));
  if(!err && mpp>0) err=imnew(xpix,ypix,mpp,&((*imp)->sim[AL]));
 }

 return(err);
}





int greypal(int * pal,int ncolours)
{
 int i;
 int r;
 int g;
 int b;

 for(i=0;i<ncolours;i++)
 {
  r=(pal[i]>>8) & 0xFF;
  g=(pal[i]>>16) & 0xFF;
  b=(pal[i]>>24) & 0xFF;
  if(r!=g || g!=b) return(0);
 }
 return(1);
}


int imgrey(imagestr * image)
{
 if(image->bpp>8) return(0);
 return(greypal(image->ipal.word,image->ipal.ncolours));
}



void imsetgreypal(imagestr * image,int bpp)
{
 int i;
 int palw;

 image->ipal.ncolours=1<<bpp;

 switch(image->bpp)
 {
  case 8:
         for(i=0;i<256;i++)
         {
          palw=(i<<24)|(i<<16)|(i<<8);
          image->ipal.word[i]=palw;
         }
         break;

  case 1:
         image->ipal.word[0]=0;
         image->ipal.word[1]=0xFFFFFF00;
         break;

  case 2:
         image->ipal.word[0]=0;
         image->ipal.word[1]=0x55555500;
         image->ipal.word[2]=0xAAAAAA00;
         image->ipal.word[3]=0xFFFFFF00;
         break;

  case 4:
         for(i=0;i<16;i++)
         {
          palw=(i<<28)|(i<<24)|(i<<20)|(i<<16)|(i<<12)|(i<<8);
          image->ipal.word[i]=palw;
         }
         break;
 }
}


int imbpp(int colours)
{
 int bpp;

 bpp=0;

 while(colours/=2) bpp++;

 while(1)
 {
  if(bpp==1 || bpp==2 || bpp==4 || bpp==8 || bpp==24) break;
  else
  if(bpp>=32)
  {
   bpp=32;
   break;
  }
  else  bpp++;
 }
 return(bpp);
}


